/* ympd
   (c) 2013-2014 Andrew Karpow <andy@ndyk.de>
   This project's homepage is: http://www.ympd.org
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

var socket;
var last_state;
var last_outputs;
var current_app;
var pagination = 0;
var browsepath;
var lastSongTitle = "";
var current_song = new Object();
var MAX_ELEMENTS_PER_PAGE = 500;
var dirble_selected_cat = "";
var dirble_catid = "";
var dirble_page = 1;
var isTouch = Modernizr.touch ? 1 : 0;

var app = $.sammy(function() {

    function runBrowse() {
        current_app = 'queue';
        $('#breadcrump').animate({'top':'34px'},300).fadeOut(100);
        $('#salamisandwich').removeClass('hide').find("tr:gt(0)").remove();
        $('#dirble_panel').addClass('hide');
        socket.send('MPD_API_GET_QUEUE,'+pagination);

        $('#panel-heading').html("<span class='glyphicon glyphicon-list'></span> Queue");
        $('#queue').addClass('active');
    }

    function prepare() {
        $('#nav_links > li').removeClass('active');
        $('#music-table-pager .page-btn').addClass('hide');
        $('#add-all-songs').hide();
        pagination = 0;
        browsepath = '';
    }

    this.get(/\#\/(\d+)/, function() {
        prepare();
        pagination = parseInt(this.params['splat'][0]);
        runBrowse();
    });

    this.get(/\#\/browse\/(\d+)\/(.*)/, function() {
        prepare();
        browsepath = this.params['splat'][1];
        pagination = parseInt(this.params['splat'][0]);
        current_app = 'browse';
        $('#breadcrump').empty().append("<li><a href=\"#/browse/0/\">root</a></li>");
        if($('#breadcrump').is(':hidden')){
          $('#breadcrump').css('top', '30px').show().animate({'top':'0px'},300);
        }
        $('#salamisandwich').removeClass('hide').find("tr:gt(0)").remove();
        $('#dirble_panel').addClass('hide');
        socket.send('MPD_API_GET_BROWSE,'+pagination+','+(browsepath ? browsepath : "/"));
        // Don't add all songs from root
        if (browsepath) {
            var add_all_songs = $('#add-all-songs');
            add_all_songs.off(); // remove previous binds
            add_all_songs.on('click', function() {
                socket.send('MPD_API_ADD_TRACK,'+browsepath);
            });
            add_all_songs.show();
        }

        $('#panel-heading').html("<span class='glyphicon glyphicon-plus-sign'></span> Browse database: "+browsepath);
        var path_array = browsepath.split('/');
        var full_path = "";
        $.each(path_array, function(index, chunk) {
            if(path_array.length - 1 == index) {
                $('#breadcrump').append("<li class=\"active\">"+ chunk + "</li>");
                return;
            }
            full_path = full_path + chunk;
            $('#breadcrump').append("<li><a href=\"#/browse/0/" + full_path + "\">"+chunk+"</a></li>");
            full_path += "/";
        });
        $('#browse').addClass('active');
    });

    this.get(/\#\/search\/(.*)/, function() {
        current_app = 'search';
        $('#salamisandwich').find("tr:gt(0)").remove();
        $('#dirble_panel').addClass('hide');
        var searchstr = this.params['splat'][0];

        $('#search > div > input').val(searchstr);
        socket.send('MPD_API_SEARCH,' + searchstr);

        $('#panel-heading').text("Search: "+searchstr);
    });

/*
    this.get(/\#\/dirble\/(\d+)\/(\d+)/, function() {
        prepare();
        current_app = 'dirble';
        $('#breadcrump').removeClass('hide').empty().append("<li><a href=\"#/dirble/\">Categories</a></li><li>"+dirble_selected_cat+"</li>");
        $('#salamisandwich').addClass('hide');
        $('#dirble_panel').removeClass('hide');
        $('#dirble_loading').removeClass('hide');
        $('#dirble_left').find("tr:gt(0)").remove();
        $('#dirble_right').find("tr:gt(0)").remove();

        $('#panel-heading').text("Dirble");
        $('#dirble').addClass('active');

        $('#next').addClass('hide');

        if (this.params['splat'][1] > 1) $('#prev').removeClass('hide');
        else $('#prev').addClass('hide');

        dirble_catid = this.params['splat'][0];
        dirble_page = this.params['splat'][1];

        dirble_load_stations();
    });


    this.get(/\#\/dirble\//, function() {
        prepare();
        current_app = 'dirble';
        $('#breadcrump').removeClass('hide').empty().append("<li>Categories</li>");
        $('#salamisandwich').addClass('hide');
        $('#dirble_panel').removeClass('hide');
        $('#dirble_loading').removeClass('hide');
        $('#dirble_left').find("tr:gt(0)").remove();
        $('#dirble_right').find("tr:gt(0)").remove();

        $('#panel-heading').text("Dirble");
        $('#dirble').addClass('active');

        dirble_load_categories();
    });
*/
    this.get("/", function(context) {
        context.redirect("#/0");
    });
});

$(document).ready(function(){
    webSocketConnect();

    $('#breadcrump').hide();

    $("#nav_links .volumeslider").slider(0);
    $("#nav_links .volumeslider").on('slider.newValue', function(evt,data){
        $('#nav_links .progress-bar').text(data.val + "%");
        socket.send("MPD_API_SET_VOLUME,"+data.val);
    });
    $('#carousel-example-generic .progressbar').slider(0);
    $('#carousel-example-generic .progressbar').on('slider.newValue', function(evt,data){
        if(current_song && current_song.currentSongId >= 0) {
            var seekVal = Math.ceil(current_song.totalTime*(data.val/100));
            socket.send("MPD_API_SET_SEEK,"+current_song.currentSongId+","+seekVal);
        }
    });

    $('#salamisandwich').hover(
        function(){
            $(this).addClass("visible-scrollbar");
        },
        function(){
            $(this).removeClass("visible-scrollbar");
        }
    );

    $('#addstream').on('shown.bs.modal', function () {
        $('#streamurl').focus();
     })
    $('#addstream form').on('submit', function (e) {
        addStream();
    });

    $("#nav_links .volume-menu").click(function(e) {
        e.stopPropagation();
    }); 

    $('#carousel-example-generic .cover-art').css("background-image", "url(/assets/no-image0.jpg)");

    $.getJSON( "/plugins/.plugin.json?t=" + Date.now(), function( data ) {
        for(i=0; i < data.plugins.length; i++){
            if(data.plugins[i].active == "yes"){
                $("#menu").append(
                 '<li role="separator" class="divider"></li>'
                +'<li><a href="#" onclick="event.preventDefault();activatePlugin(\''+data.plugins[i].menu +'\',\''+data.plugins[i].icon +'\',\''+data.plugins[i].command +'\',\''+data.plugins[i].form +'\',\''+data.plugins[i].output+'\',\''+data.plugins[i].success+'\',\''+data.plugins[i].error+'\');return false;">'
                +'<span class="glyphicon glyphicon-' + data.plugins[i].icon + '"></span> ' + data.plugins[i].menu + '</a></li>'
                );
                $("#nav_links").append(
                 '<li class="visible-xs"><a href="#" onclick="event.preventDefault();activatePlugin(\''+data.plugins[i].menu +'\',\''+data.plugins[i].icon +'\',\''+data.plugins[i].command +'\',\''+data.plugins[i].form +'\',\''+data.plugins[i].output+'\',\''+data.plugins[i].success+'\',\''+data.plugins[i].error+'\');return false;">'
                +'<span class="glyphicon glyphicon-' + data.plugins[i].icon + '"></span></a></li>'
                );
            }
        }
    });

    /* filter */
    $("#title-filter").multifilter();

    touchDevice = (typeof window.ontouchstart) !== 'undefined'
    if(touchDevice){
        $("table.table-headerfixed tbody").css("padding-right", "12px");
    }

});

function activatePlugin(menu, icon, command, form, output, success, error){
  $("#activate-plugin")
  .data("output", output)
  .data("success", success)
  .data("error", error);
  $("#activate-plugin-title").text(" " + menu);
  $("#activate-plugin-icon")
  .removeClass()
  .addClass("glyphicon")
  .addClass("glyphicon-" + icon)

  if($.isEmptyObject(form)){
    socket.send('ACTIVATE_PLUGIN,' + command);
  }else{
    $("#plugin-form-title").text(" " + menu);
    $("#plugin-form-icon")
    .removeClass()
    .addClass("glyphicon")
    .addClass("glyphicon-" + icon)

    $("#plugin-form-msg").text("");
    $("#plugin-form .modal-body").load(form + "?t=" + Date.now());
    $("#plugin-form")
    .data("command", command)
    .modal();
  }
}

function plugin_form_ok(){
  var command = $("#plugin-form").data("command");

  var p = $('#plugin-form [name=param]');
  var param = p.val();
  if(p.attr("type") == "radio"){
    param = $('#plugin-form [name=param]:checked').val();
  }
  if($.isEmptyObject(param) && !p.hasClass("optional")){
    $("#plugin-form-msg").fadeIn(100).text("really?").fadeOut(1200);
  }else{
    $('#plugin-form').modal('hide');
    socket.send('ACTIVATE_PLUGIN,' + command + ',' + param );
  }
}

$(function(){
    var car = $('#carousel-example-generic');
    var hammer = new Hammer(car[0]);
    hammer.on('swipeleft',  function(){ car.carousel('next'); });
    hammer.on('swiperight', function(){ car.carousel('prev'); });

    car.on('slid.bs.carousel', function () {
       if($("#carousel-1").hasClass("active") && $("#queue-icon").hasClass("glyphicon-list")){
         toggleQueue();
         window.location.href = "#/";
       }
    });
});
 
$(window).load(function () {
    /* Table Height */
    var hsize = document.documentElement.clientHeight;
    $("#music-table").css("height", (hsize - 325) + "px");//340

    /* for iPhone SE */
    if(hsize < 580){
        $("#player-buttonset")
        .css("margin-top", (hsize - 600)/2 + "px")
        .css("margin-top", "-50px")
        .css("margin-bottom", "30px")
        .css("opacity", "0.9");
    }else{
        $("#player-buttonset")
        .css("margin-top", "20px")
        .css("margin-bottom", "10px")
        .css("opacity", "1");
    }

});

$(window).resize(function(){
    /* Table Height */
    var hsize = document.documentElement.clientHeight;
    $("#music-table").css("height", (hsize - 325) + "px");//340

    /* for iPhone SE */
    if(hsize < 580){
        $("#player-buttonset")
        .css("margin-top", (hsize - 600)/2 + "px")
        .css("margin-top", "-50px")
        .css("margin-bottom", "30px")
        .css("opacity", "0.9");
    }else{
        $("#player-buttonset")
        .css("margin-top", "20px")
        .css("margin-bottom", "10px")
        .css("opacity", "1");
    }
});


function toggleQueue(){
    var queue_icon   = $("#queue-icon");
    var queue_button = $("#queue-button");
    if(queue_icon.hasClass("glyphicon-plus-sign")){
        queue_button.attr("href", "#/browse/0/");
        if(queue_button.attr("browse-path") != ""){
            queue_button.attr("href", queue_button.attr("browse-path"));
        }
        queue_icon.removeClass("glyphicon-plus-sign").addClass("glyphicon-list");
        $("#music-table").hide().fadeIn(180);
        $("#cover-btn-group").css('top', '145px').animate({'top':'110px'},300);
    } else {
        queue_button.attr("href", "#/");
        queue_button.attr("browse-path", location.hash);
        queue_icon.removeClass("glyphicon-list").addClass("glyphicon-plus-sign");
        $("#music-table").hide().fadeIn(400);
        $("#cover-btn-group").css('top', '110px').animate({'top':'145px'},300);
    }
}

function volume_plus(p){
    var vol = parseInt($('#nav_links .volumeslider>div>div:first').text());
    var ret = vol+p >= 100 ? 100 : vol+p;
    $('#nav_links .progress-bar').text(ret + "%");
    return ret;
}

function volume_minus(m){
    var vol = parseInt($('#nav_links .volumeslider>div>div:first').text());
    var ret = vol-m <= 0 ? 0 : vol-m;
    $('#nav_links .progress-bar').text(ret + "%");
    return ret;
}

function webSocketConnect() {
    if (typeof MozWebSocket != "undefined") {
        socket = new MozWebSocket(get_appropriate_ws_url());
    } else {
        socket = new WebSocket(get_appropriate_ws_url());
    }

    try {
        socket.onopen = function() {
            console.log("connected");
            $('.top-right').notify({
                message:{text:"Connected to ympd"},
                fadeOut: { enabled: true, delay: 500 }
            }).show();

            app.run();
            /* emit initial request for output names */
            socket.send("MPD_API_GET_OUTPUTS");
        }

        socket.onmessage = function got_packet(msg) {
            if(msg.data === last_state || msg.data.length == 0)
                return;

            var obj = JSON.parse(msg.data);

            switch (obj.type) {
                case "queue":
                    if(current_app !== 'queue')
                        break;

                    $('#salamisandwich > tbody').empty();
                    var html = "";
                    for (var song in obj.data) {
                        var minutes = Math.floor(obj.data[song].duration / 60);
                        var seconds = obj.data[song].duration - minutes * 60;
                        html += "<tr trackid=\"" + obj.data[song].id + "\"><td>" + (obj.data[song].pos + 1) + "</td>" +
                                "<td>"+ obj.data[song].title +"</td>" + 
                                "<td class='hidden-xs'>"+ obj.data[song].artist +"</td>" + 
                                "<td class='hidden-xs'>"+ minutes + ":" + (seconds < 10 ? '0' : '') + seconds +
                                "</td><td></td></tr>";
                    }
                    $('#salamisandwich > tbody').append(html);

                    if(obj.data[obj.data.length-1].pos + 1 >= pagination + MAX_ELEMENTS_PER_PAGE)
                        $('#next').removeClass('hide');
                    if(pagination > 0)
                        $('#prev').removeClass('hide');

                    $('#salamisandwich > tbody > tr > td:last-child').append(
                        "<a class=\"pull-right btn-group-hover text-center\" style=\"width:28px;\" href=\"#/\" " +
                        "onclick=\"socket.send('MPD_API_RM_TRACK,' + $(this).parents('tr').attr('trackid')); $(this).parents('tr').remove();\">" +
                        "<span class=\"glyphicon glyphicon-trash\"></span></a>");

                    $('#salamisandwich > tbody > tr').on({
                        click: function() {
                            $('#salamisandwich > tbody > tr').removeClass('active');
                            socket.send('MPD_API_PLAY_TRACK,'+$(this).attr('trackid'));
                            $(this).addClass('active');
                        },
                    });
                    break;
                case "dashboard":
                    $.getJSON( "/RAM/.dashboard.json?t=" + Date.now(), function( data ) {
                        var items = [];
                        $.each( data, function( key, val ) {
                            if(key=="arm_freq" || key=="core_freq"){
                              return true;
                            }
                            items.push( "<tr><td>" + key + "</td><td>" + val + "</td></tr>" );
                        });
                        $("#dashboard-contents").html(items.join(""));
                        $("#canvas_holder").css("background-image", "url(/RAM/.latency.svg?t=" + Date.now() + ")").show();
                        dashboard_meter(parseInt(data["arm_freq"]/1000000), parseInt(data["core_freq"]/1000000));
                    });
                    $('#wait-dashboard').hide();
                    break;
                case "search":
                    $('#wait').modal('hide');
                case "browse":
                    if(current_app !== 'browse' && current_app !== 'search')
                        break;

                    /* The use of encodeURI() below might seem useless, but it's not. It prevents
                     * some browsers, such as Safari, from changing the normalization form of the
                     * URI from NFD to NFC, breaking our link with MPD.
                     */
                    $('#salamisandwich > tbody').empty();
                    $("#music-table").hide().fadeIn(180);
                    var html = "";
                    for (var item in obj.data) {
                        switch(obj.data[item].type) {
                            case "directory":
                                html += "<tr uri=\"" + encodeURI(obj.data[item].dir) + "\" class=\"dir\">" +
                                        "<td><span class=\"glyphicon glyphicon-folder-open\"></span></td>" +
                                        "<td><a>" + basename(obj.data[item].dir) + "</a></td>" +
                                        "<td class='hidden-xs'></td>" + 
                                        "<td class='hidden-xs'></td><td></td></tr>"
                                break;
                            case "playlist":
                                html += "<tr uri=\"" + encodeURI(obj.data[item].plist) + "\" class=\"plist\">" +
                                        "<td><span class=\"glyphicon glyphicon-list\"></span></td>" +
                                        "<td><a>" + basename(obj.data[item].plist) + "</a></td>" +
                                        "<td class='hidden-xs'></td>" + 
                                        "<td class='hidden-xs'></td><td></td></tr>"
                                break;
                            case "song":
                                var minutes = Math.floor(obj.data[item].duration / 60);
                                var seconds = obj.data[item].duration - minutes * 60;

                                html += "<tr uri=\"" + encodeURI(obj.data[item].uri) + "\" class=\"song\">" +
                                        "<td><span class=\"glyphicon glyphicon-music\"></span></td>" +
                                        "<td>"+ obj.data[item].title +"</td>" +
                                        "<td class='hidden-xs'>"+ obj.data[item].artist +"</td>" + 
                                        "<td class='hidden-xs'>"+ minutes + ":" + (seconds < 10 ? '0' : '') + seconds +
                                        "</td><td></td></tr>"
                                break;
                            case "wrap":
                                if(current_app == 'browse') {
                                    $('#next').removeClass('hide');
                                } else {
                                    html += "<tr><td><span class=\"glyphicon glyphicon-remove\"></span></td>" + 
                                            "<td>Too many results, please refine your search!</td>" + 
                                            "<td class='hidden-xs'></td>" + 
                                            "<td></td><td></td></tr>"
                                }
                                break;
                        }

                        if(pagination > 0)
                            $('#prev').removeClass('hide');
                    }
                    $('#salamisandwich > tbody').append(html);

                    function appendClickableIcon(appendTo, onClickAction, glyphicon) {
                        $(appendTo).append(
                            "<a role=\"button\" class=\"pull-right btn-group-hover text-center\" style=\"width:28px;\">" +
                            "<span class=\"glyphicon glyphicon-" + glyphicon + "\"></span></a>")
                            .find('a').click(function(e) {
                                e.stopPropagation();
                                socket.send(onClickAction + "," + decodeURI($(this).parents("tr").attr("uri")));
                            $('.top-right').notify({
                                message:{
                                    text: $('td:nth-child(2)', $(this).parents("tr")).text() + " added"
                                } }).show();
                            }).fadeTo('fast',1);
                    }

                    appendClickableIcon($("#salamisandwich > tbody > tr.dir > td:last-child"), 'MPD_API_ADD_TRACK', 'plus');
                    appendClickableIcon($("#salamisandwich > tbody > tr.plist > td:last-child"), 'MPD_API_ADD_PLAYLIST', 'plus');
                    appendClickableIcon($("#salamisandwich > tbody > tr.song > td:last-child"), 'MPD_API_ADD_TRACK', 'play');

                    $('#salamisandwich > tbody > tr').on({
                        click: function() {
                            switch($(this).attr('class')) {
                                case 'dir':
                                    pagination = 0;
                                    browsepath = $(this).attr("uri");
                                    $("#browse > a").attr("href", '#/browse/'+pagination+'/'+browsepath);
                                    app.setLocation('#/browse/'+pagination+'/'+browsepath);
                                    break;
                                case 'song':
                                    socket.send("MPD_API_ADD_TRACK," + decodeURI($(this).attr("uri")));
                                    $('.top-right').notify({
                                        message:{
                                            text: $('td:nth-child(2)', this).text() + " added"
                                        }
                                    }).show();
                                    break;
                                case 'plist':
                                    socket.send("MPD_API_ADD_PLAYLIST," + decodeURI($(this).attr("uri")));
                                    $('.top-right').notify({
                                        message:{
                                            text: "Playlist " + $('td:nth-child(2)', this).text() + " added"
                                        }
                                    }).show();
                                    break;
                            }
                        }
                    });

                    break;
                case "state":
                    updatePlayIcon(obj.data.state);
                    updateVolumeIcon(obj.data.volume);

                    var progress = Math.floor(100*obj.data.elapsedTime/obj.data.totalTime);
                    $('#carousel-example-generic .progressbar').slider(progress);

                    $('#nav_links .volumeslider').slider(obj.data.volume);
                    $('#nav_links .progress-bar').text(obj.data.volume + "%");

                    if(JSON.stringify(obj) === JSON.stringify(last_state))
                        break;

                    current_song.totalTime  = obj.data.totalTime;
                    current_song.currentSongId = obj.data.currentsongid;
                    var total_minutes = Math.floor(obj.data.totalTime / 60);
                    var total_seconds = obj.data.totalTime - total_minutes * 60;

                    var elapsed_minutes = Math.floor(obj.data.elapsedTime / 60);
                    var elapsed_seconds = obj.data.elapsedTime - elapsed_minutes * 60;

                    $('.counter')
                    .text(elapsed_minutes + ":" + 
                        (elapsed_seconds < 10 ? '0' : '') + elapsed_seconds + " / " +
                        total_minutes + ":" + (total_seconds < 10 ? '0' : '') + total_seconds);

                    $('#salamisandwich > tbody > tr').removeClass('active').css("font-weight", "");
                    $('#salamisandwich > tbody > tr[trackid='+obj.data.currentsongid+']').addClass('active').css("font-weight", "bold");

                    if(obj.data.random)
                        $('#btnrandom').addClass("active")
                    else
                        $('#btnrandom').removeClass("active");

                    if(obj.data.consume)
                        $('#btnconsume').addClass("active")
                    else
                        $('#btnconsume').removeClass("active");

                    if(obj.data.single)
                        $('#btnsingle').addClass("active")
                    else
                        $('#btnsingle').removeClass("active");

                    if(obj.data.crossfade)
                        $('#btncrossfade').addClass("active")
                    else
                        $('#btncrossfade').removeClass("active");

                    if(obj.data.repeat)
                        $('#btnrepeat').addClass("active")
                    else
                        $('#btnrepeat').removeClass("active");

                    last_state = obj;
                    break;
                case "outputnames":
                    $('#btn-outputs-block button').remove();
                    $.each(obj.data, function(id, name){
                        var btn = $('<button id="btnoutput'+id+'" class="btn btn-default" onclick="toggleoutput(this, '+id+')"><span class="glyphicon glyphicon-volume-up"></span> '+name+'</button>');
                        btn.appendTo($('#btn-outputs-block'));
                    });
                    /* remove cache, since the buttons have been recreated */
                    last_outputs = '';
                    break;
                case "outputs":
                    if(JSON.stringify(obj) === JSON.stringify(last_outputs))
                        break;
                    $.each(obj.data, function(id, enabled){
                        if (enabled)
                        $('#btnoutput'+id).addClass("active");
                        else
                        $('#btnoutput'+id).removeClass("active");
                    });
                    last_outputs = obj;
                    break;
                case "disconnected":
                    if($('.top-right').has('div').length == 0)
                        $('.top-right').notify({
                            message:{text:"ympd lost connection to MPD "},
                            type: "danger",
                            fadeOut: { enabled: true, delay: 1000 },
                        }).show();
                    break;
                case "update_queue":
                    if(current_app === 'queue')
                        socket.send('MPD_API_GET_QUEUE,'+pagination);
                    break;
                case "song_change":

                    $('#carousel-example-generic .album').text("");
                    $('#carousel-example-generic .artist').text("");

                    $('#carousel-example-generic .currenttrack').hide().text(" " + obj.data.title).fadeIn(500);
                    var notification = "<strong><h4>" + obj.data.title + "</h4></strong>";

                    if(obj.data.uri) {
                        var default_img_no = Math.floor(Math.random()*2);
                        if(obj.data.uri.startsWith("http")){
                            var url = "url(/assets/no-image"+ default_img_no  + ".jpg)";
                            $('#carousel-example-generic .cover-art').css("background-image", url );
                        }else{
                            cover_art_url(obj.data.artist, obj.data.album, "mega", function (err, lastfmurl) {
                                var uri_raw = obj.data.uri.split("/");
                                uri_raw.splice(-1,1);
                                $.each(uri_raw, function(i, val){
                                  uri_raw[i] = encodeURIComponent(val).replace(/\(/g, "\\(").replace(/\)/g, "\\)").replace(/\'/g, "\\'");
                                });
                                var uri     = "/" + uri_raw.join("/") + "/";
                                var url     = "";
                                url += "url(" + uri + encodeURIComponent(obj.data.artist).replace(/\(/g, "\\(").replace(/\)/g, "\\)").replace(/\'/g, "\\'") + "%20-%20" + encodeURIComponent(obj.data.album).replace(/\(/g, "\\(").replace(/\)/g, "\\)").replace(/\'/g, "\\'") + ".jpg" + "), ";
                                url += "url(" + uri + "folder.jpg" + "), url(" + uri + "Folder.jpg" + "), ";
                                url += "url(" + lastfmurl + "), ";
                                url += "url(/assets/no-image"+ default_img_no  + ".jpg)";
                                $('#carousel-example-generic .cover-art').css("background-image", url );
                            });
                        }
                    }
                    if(obj.data.album) {
                        $('#carousel-example-generic .album').text(obj.data.album);
                        notification += obj.data.album + "<br />";
                    }
                    if(obj.data.artist) {
                        $('#carousel-example-generic .artist').text(obj.data.artist);
                        notification += obj.data.artist + "<br />";
                    }

                    /*
                    if ($.cookie("notification") === "true")
                        songNotify(obj.data.title, obj.data.artist, obj.data.album );
                    else
                        $('.top-right').notify({
                            message:{html: notification},
                            type: "info",
                        }).show();
                    */
  
                    break;
                case "mpdhost":
                    $('#mpdnas').val($.trim(obj.data.nas));
                    $('#mpdnasuser').val($.trim(obj.data.nasuser));
                    $('#mpdnaspw').val($.trim(obj.data.naspw));
                    break;
                case "error":
                    $('.top-right').notify({
                        message:{text: obj.data},
                        type: "danger",
                    }).show();
                    $('#nav_links .setting-icon').removeClass('gly-spin');
                    break;
                case "success":
                    $('.top-right').notify({
                        message:{text: obj.data},
                        type: "success",
                    }).show();
                    $('#nav_links .setting-icon').removeClass('gly-spin');
                    break;
                case "nas_start":
                    $('.top-right').notify({
                        message:{text: obj.data},
                        type: "info",
                    }).show();
                    break;
                case "update_start":
		    $(".modal-footer > button").prop("disabled", true);
		    $("#update-progress .modal-body").text("");
                    var checktimer = setInterval(function(){
                        $("#update-progress").modal();
		        $("#update-progress .modal-body").load("/RAM/.update.log?t=" + Date.now(),"",function(data, status, object) {
                            if(data.endsWith("succeeded\n") || data.endsWith("completed\n")){
                                clearInterval(checktimer);
			        $(".modal-footer > button").prop("disabled", false);
                                $('#nav_links .setting-icon').removeClass('gly-spin');
                            }else{
                            }
                        });
                    }, 200);
		    break;
                case "plugin":
                    if(obj.data == "success" && $("#activate-plugin").data("output") != ""){
                        $("#activate-plugin .modal-body").load($("#activate-plugin").data("output") + "?t=" + Date.now());
                        $("#activate-plugin").modal();
                    }else if(obj.data == "success" && $("#activate-plugin").data("success") != ""){
                        $('.top-right').notify({
                            message:{text: $("#activate-plugin").data("success")},
                            type: "success",
                        }).show();
                    }else if($("#activate-plugin").data("error") != ""){
                        $('.top-right').notify({
                            message:{text: $("#activate-plugin").data("error")},
                            type: "danger",
                        }).show();
                    }
                    break;
                default:
                    break;
            }

        }
        socket.onclose = function(){
            console.log("disconnected");
            $('.top-right').notify({
                message:{text:"Connection to ympd lost, retrying in 3 seconds "},
                type: "danger",
                onClose: function () {
                    webSocketConnect();
                }
            }).show();
        }

    } catch(exception) {
        alert('<p>Error' + exception);
    }

}

function get_appropriate_ws_url()
{
    var pcol;
    var u = document.URL;

    /*
    /* We open the websocket encrypted if this page came on an
    /* https:// url itself, otherwise unencrypted
    /*/

    if (u.substring(0, 5) == "https") {
        pcol = "wss://";
        u = u.substr(8);
    } else {
        pcol = "ws://";
        if (u.substring(0, 4) == "http")
            u = u.substr(7);
    }

    u = u.split('#');

    return pcol + u[0] + "/ws";
}

var updateVolumeIcon = function(volume)
{
    $("#volume-icon")
    .removeClass("glyphicon-volume-off")
    .removeClass("glyphicon-volume-up")
    .removeClass("glyphicon-volume-down");

    if(volume == 0) {
        $("#volume-icon").addClass("glyphicon-volume-off");
    } else if (volume < 50) {
        $("#volume-icon").addClass("glyphicon-volume-down");
    } else {
        $("#volume-icon").addClass("glyphicon-volume-up");
    }
}

var updatePlayIcon = function(state)
{
    $("#carousel-example-generic .play-icon")
    .removeClass("glyphicon-play")
    .removeClass("glyphicon-pause");

    $('#track-icon')
    .removeClass("glyphicon-play")
    .removeClass("glyphicon-pause")
    .removeClass("glyphicon-stop");

    if(state == 1) { // stop
        $(".glyphicon-headphones").removeClass("gly-head");
        $("#carousel-example-generic .play-icon").addClass("glyphicon-play");
        $('#track-icon').addClass("glyphicon-stop");
        socket.send('MPD_API_SET_STOP');
    } else if(state == 2) { // pause
        $(".glyphicon-headphones").addClass("gly-head");
        $("#carousel-example-generic .play-icon").addClass("glyphicon-pause");
        $('#track-icon').addClass("glyphicon-play");
    } else { // play
        $(".glyphicon-headphones").removeClass("gly-head");
        $("#carousel-example-generic .play-icon").addClass("glyphicon-play");
        $('#track-icon').addClass("glyphicon-pause");
    }
}

function systemReboot() {
    $("#reboot-confirm").modal('hide');
    socket.send('SYSTEM_REBOOT');
    $('.top-right').notify({
        message:{text:"symphonic-mpd reboot... "}
    }).show();
}

function systemPowerOff() {
    $("#poweroff-confirm").modal('hide');
    socket.send('SYSTEM_POWEROFF');
    $('.top-right').notify({
        message:{text:"symphonic-mpd shutdown... "}
    }).show();
}

function updateDB() {
    socket.send('MPD_API_UPDATE_DB');
    $('.top-right').notify({
        message:{text:"Updating MPD Database... "}
    }).show();
}

function clickPlay() {
    if($('#track-icon').hasClass('glyphicon-play')){
        socket.send('MPD_API_SET_PAUSE');
    }else{
        socket.send('MPD_API_SET_PLAY');
    }
}

function basename(path) {
    return path.split('/').reverse()[0];
}

$('#btnrandom').on('click', function (e) {
    socket.send("MPD_API_TOGGLE_RANDOM," + ($(this).hasClass('active') ? 0 : 1));

});
$('#btnconsume').on('click', function (e) {
    socket.send("MPD_API_TOGGLE_CONSUME," + ($(this).hasClass('active') ? 0 : 1));

});
$('#btnsingle').on('click', function (e) {
    socket.send("MPD_API_TOGGLE_SINGLE," + ($(this).hasClass('active') ? 0 : 1));
});
$('#btncrossfade').on('click', function(e) {
    socket.send("MPD_API_TOGGLE_CROSSFADE," + ($(this).hasClass('active') ? 0 : 1));
});
$('#btnrepeat').on('click', function (e) {
    socket.send("MPD_API_TOGGLE_REPEAT," + ($(this).hasClass('active') ? 0 : 1));
});

function toggleoutput(button, id) {
    socket.send("MPD_API_TOGGLE_OUTPUT,"+id+"," + ($(button).hasClass('active') ? 0 : 1));
}

$('#btnnotify').on('click', function (e) {
    if($.cookie("notification") === "true") {
        $.cookie("notification", false);
    } else {
        Notification.requestPermission(function (permission) {
            if(!('permission' in Notification)) {
                Notification.permission = permission;
            }

            if (permission === "granted") {
                $.cookie("notification", true, { expires: 424242 });
                $('btnnotify').addClass("active");
            }
        });
    }
});

function getDashboard() {
    $("#canvas_holder").hide();
    $("#canvas_holder").css("background-image", "");
    $('#wait-dashboard').show();
    socket.send('MPD_API_GET_DASHBOARD');
}

function inplaceUpdate(){
    $("#update_button").prop("disabled", true);
    socket.send('INPLACE_UPDATE');
    $("#update_icon").css('color', 'Black');
    $("#version_available").text("");
    $('#settings').modal('hide');
    $('#nav_links .setting-icon').addClass('gly-spin');
}

function getHost() {
    socket.send('MPD_API_GET_MPDHOST');

    function onEnter(event) {
      if ( event.which == 13 ) {
        confirmSettings();
      }
    }

    $('#mpdnas').keypress(onEnter);
    $('#mpdnasuser').keypress(onEnter);
    $('#mpdnaspw').keypress(onEnter);

    var version_available = new Object();

    var version="v0.9.x";
    $.getJSON( "http://mpd.sytes.net/release/" + version + "/.smpd-version.json?t=" + Date.now(), function( data ) {
      version_available.major = data.major;
      version_available.minor = data.minor;
      version_available.revision = data.revision;
 
      $.getJSON( "/.version.json?t=" + Date.now(), function( data ) {
        $("#version_applied").text(" v" + data.major + "." + data.minor + "." + data.revision );
        if (version_available.major == data.major && version_available.minor == data.minor &&  version_available.revision > data.revision ){
          $("#update_button").prop("disabled", false);
          $("#version_available").text(' v' + version_available.major + '.' + version_available.minor + '.' + version_available.revision + ' available');
          $("#update_icon").css('color', 'Red');
        }
      });
    });
}

$('#search').submit(function () {
    app.setLocation("#/search/"+$('#search > div > input').val());
    $('#wait').modal('show');
    setTimeout(function() {
        $('#wait').modal('hide');
    }, 10000);
    return false;
});

$('#music-table-pager .page-btn').on('click', function (e) {

    switch ($(this).text()) {
        case "Next":
            if (current_app == "dirble") dirble_page++;
            else pagination += MAX_ELEMENTS_PER_PAGE;
            break;
        case "Previous":
            if (current_app == "dirble") dirble_page--
            else {
                pagination -= MAX_ELEMENTS_PER_PAGE;
                if(pagination <= 0)
                    pagination = 0;
            }
            break;
    }

    switch(current_app) {
        case "queue":
            app.setLocation('#/'+pagination);
            break;
        case "browse":
            app.setLocation('#/browse/'+pagination+'/'+browsepath);
            break;
        case "dirble":
            app.setLocation("#/dirble/"+dirble_catid+"/"+dirble_page);
            break;
    }
    e.preventDefault();
});

function addStream() {
    if($('#streamurl').val().length > 0) {
    	socket.send('MPD_API_ADD_TRACK,'+$('#streamurl').val());
    }
    $('#streamurl').val("");
    $('#addstream').modal('hide');
}

function saveQueue() {
    if($('#playlistname').val().length > 0) {
    	socket.send('MPD_API_SAVE_QUEUE,'+$('#playlistname').val());
    }
    $('#savequeue').modal('hide');
}

function confirmSettings() {

    //$('.top-right').notify({
    //    message:{text:"NAS setting trying... Wait 30 seconds"}
    //}).show();

    $('#settings').modal('hide');
    $('#nav_links .setting-icon').addClass('gly-spin');

    $(".modal-footer > button").prop("disabled", true);
    $("#nas-progress .modal-body").text("");
    $("#nas-progress").modal();
    var checktimer = setInterval(function(){
	$("#nas-progress .modal-body").load("/RAM/.nas_setting.log?t=" + Date.now(),"",function(data, status, object) {
            if(data.endsWith("successed\n")){
                clearInterval(checktimer);
		$(".modal-footer > button").prop("disabled", false);
                $('#nav_links .setting-icon').removeClass('gly-spin');
                $('.top-right').notify({
                    message:{text: "NAS Setting complete :)"},
                    type: "success",
                }).show();
            }
        });
    }, 200);

    var send_str = 'MPD_API_SET_MPDHOST,'+$('#mpdnas').val()+','+$('#mpdnasuser').val();
    if ($.trim($('#mpdnaspw').val()).length > 0) {
        send_str += ','+$('#mpdnaspw').val();
    }
    socket.send(send_str);
}

function modeSelect() {
    socket.send('MPD_API_TOGGLE_MODE');
    $('.top-right').notify({
        message:{text:"mode setting trying... "}
    }).show();

    if(this.id == "mode-accurate"){
        $('#mode-symphonic').removeClass("btn-primary").addClass("btn-default").prop("disabled", false);
        $('#mode-accurate').removeClass("btn-default").addClass("btn-primary").prop("disabled", true);
    } else {
        $('#mode-accurate').removeClass("btn-primary").addClass("btn-default").prop("disabled", false);
        $('#mode-symphonic').removeClass("btn-default").addClass("btn-primary").prop("disabled", true);     
    }
    $('#settings').modal('hide');
}

$('#mpd_password_set > button').on('click', function (e) {
    socket.send('MPD_API_SET_MPDPASS,');
    $('#mpd_pw').val("");
    $('#mpd_pw_con').val("");
    $('#mpd_password_set').addClass('hide');
})

function notificationsSupported() {
    return "Notification" in window;
}

function songNotify(title, artist, album) {
    /*var opt = {
        type: "list",
        title: title,
        message: title,
        items: []
    }
    if(artist.length > 0)
        opt.items.push({title: "Artist", message: artist});
    if(album.length > 0)
        opt.items.push({title: "Album", message: album});
*/
    //chrome.notifications.create(id, options, creationCallback);

    var textNotification = "";
    if(typeof artist != 'undefined' && artist.length > 0)
        textNotification += " " + artist;
    if(typeof album != 'undefined' && album.length > 0)
        textNotification += "\n " + album;

	var notification = new Notification(title, {icon: 'assets/favicon.ico', body: textNotification});
    setTimeout(function(notification) {
        notification.close();
    }, 3000, notification);
}

$(document).keydown(function(e){
    if (e.target.tagName == 'INPUT') {
        return;
    }
    switch (e.which) {
        case 37: //left
            socket.send('MPD_API_SET_PREV');
            break;
        case 39: //right
            socket.send('MPD_API_SET_NEXT');
            break;
        case 32: //space
            clickPlay();
            break;
        default:
            return;
    }
    e.preventDefault();
});

function dirble_load_categories() {

    dirble_page = 1;

    $.getJSON( "http://api.dirble.com/v2/categories?token=bc44e29bb37d7f4889ac086fa0", function( data ) {

        $('#dirble_loading').addClass('hide');

        data = data.sort(function(a, b) {
            return (a.title > b.title) ? 1 : 0;
        });

        var max = data.length - data.length%2;

        for(i = 0; i < max; i+=2) {

            $('#dirble_left > tbody').append(
                "<tr><td catid=\""+data[i].id+"\">"+data[i].title+"</td></tr>"
            );

            $('#dirble_right > tbody').append(
                "<tr><td catid=\""+data[i+1].id+"\">"+data[i+1].title+"</td></tr>"
            );
        }

        if (max != data.length) {
            $('#dirble_left > tbody').append(
                "<tr><td catid=\""+data[max].id+"\">"+data[max].title+"</td></tr>"
            );
        }

        $('#dirble_left > tbody > tr > td').on({
            click: function() {
                dirble_selected_cat = $(this).text();
                dirble_catid = $(this).attr("catid");
                app.setLocation("#/dirble/"+dirble_catid+"/"+dirble_page);
            }
        });

        $('#dirble_right > tbody > tr > td').on({
            click: function() {
                dirble_selected_cat = $(this).text();
                dirble_catid = $(this).attr("catid");
                app.setLocation("#/dirble/"+dirble_catid+"/"+dirble_page);
            }
        });
    });
}


function dirble_load_stations() {

    $.getJSON( "http://api.dirble.com/v2/category/"+dirble_catid+"/stations?page="+dirble_page+"&per_page=20&token=bc44e29bb37d7f4889ac086fa0", function( data ) {

        $('#dirble_loading').addClass('hide');
        if (data.length == 20) $('#next').removeClass('hide');

        var max = data.length - data.length%2;

        for(i = 0; i < max; i+=2) {

            $('#dirble_left > tbody').append(
                "<tr><td radioid=\""+data[i].id+"\">"+data[i].name+"</td></tr>"
            );
            $('#dirble_right > tbody').append(
                "<tr><td radioid=\""+data[i+1].id+"\">"+data[i+1].name+"</td></tr>"
            );
        }

        if (max != data.length) {
            $('#dirble_left > tbody').append(
                "<tr><td radioid=\""+data[max].id+"\">"+data[max].name+"</td></tr>"
            );
        }

        $('#dirble_left > tbody > tr > td').on({
            click: function() {
                var _this = $(this);

                $.getJSON( "http://api.dirble.com/v2/station/"+$(this).attr("radioid")+"?token=bc44e29bb37d7f4889ac086fa0", function( data ) {

                    socket.send("MPD_API_ADD_TRACK," + data.streams[0].stream);
                    $('.top-right').notify({
                        message:{
                            text: _this.text() + " added"
                        }
                    }).show();
                });
            },
            mouseenter: function() {
                var _this = $(this);

                $(this).last().append(
                "<a role=\"button\" class=\"pull-right btn-group-hover\">" +
                "<span class=\"glyphicon glyphicon-play\"></span></a>").find('a').click(function(e) {
                    e.stopPropagation();

                    $.getJSON( "http://api.dirble.com/v2/station/"+_this.attr("radioid")+"?token=bc44e29bb37d7f4889ac086fa0", function( data ) {

                        socket.send("MPD_API_ADD_PLAY_TRACK," + data.streams[0].stream);
                        $('.top-right').notify({
                            message:{
                                text: _this.text() + " added"
                            }
                        }).show();
                    });
                }).fadeTo('fast',1);
            },

            mouseleave: function(){
                $(this).last().find("a").stop().remove();
            }
        });

        $('#dirble_right> tbody > tr > td').on({
            click: function() {
                var _this = $(this);

                $.getJSON( "http://api.dirble.com/v2/station/"+$(this).attr("radioid")+"?token=bc44e29bb37d7f4889ac086fa0", function( data ) {

                    socket.send("MPD_API_ADD_TRACK," + data.streams[0].stream);
                    $('.top-right').notify({
                        message:{
                            text: _this.text() + " added"
                        }
                    }).show();
                });
            },
            mouseenter: function() {
                var _this = $(this);

                $(this).last().append(
                "<a role=\"button\" class=\"pull-right btn-group-hover\">" +
                "<span class=\"glyphicon glyphicon-play\"></span></a>").find('a').click(function(e) {
                    e.stopPropagation();

                    $.getJSON( "http://api.dirble.com/v2/station/"+_this.attr("radioid")+"?token=bc44e29bb37d7f4889ac086fa0", function( data ) {

                        socket.send("MPD_API_ADD_PLAY_TRACK," + data.streams[0].stream);
                        $('.top-right').notify({
                            message:{
                                text: _this.text() + " added"
                            }
                        }).show();
                    });
                }).fadeTo('fast',1);
            },

            mouseleave: function(){
                $(this).last().find("a").stop().remove();
            }
        });
    });
}

function dashboard_meter(_arm_freq, _core_freq){
  var arm_freq  = _arm_freq;
  var core_freq = _core_freq;

  var arm_ctx = document.getElementById('arm').getContext('2d');
  var myChart = new Chart(arm_ctx, {
    type: 'doughnut',
    data: {
      datasets: [
        {
        borderColor:["white","white","white","white","white","white","white","white","white","white","white","white","white","white","white","rgba(0,0,0,0)"],
        data: [1, 1, 1, 1, 1, 1, 1,1,1,1,1,1,1,1,1,5],
        backgroundColor: ["gray","gray","gray","gray","gray","gray","gray","gray","gray","gray","gray","gray","red","red","red","rgba(255,255,255,0)"]
        },
        {
        borderColor:["#eaeaea","rgba(0,0,0,0)", "rgba(0,0,0,0)"],
        data: [270*arm_freq/1500, 270*(1500-arm_freq)/1500, 90],
        backgroundColor: ["rgba(153,255,51,0.6)", "rgba(0,0,0,0)", "rgba(0,0,0,0)"]
        }
      ]
    },
    options: {tooltips:{enabled:false}, title:{display:true, text:["ARM", arm_freq], padding:-74}, rotation: 0.75 * Math.PI, animation:{animateScale: true}}
  });

  var core_ctx = document.getElementById('core').getContext('2d');
  var myChart = new Chart(core_ctx, {
    type: 'doughnut',
    data: {
      datasets: [
        {
        borderColor:["white","white","white","white","white","white","rgba(0,0,0,0)"],
        data: [1, 1, 1, 1, 1, 1, 2],
        backgroundColor: ["gray","gray","gray","gray","red","red","rgba(0,0,0,0)"]
        },
        {
        borderColor:["#eaeaea","rgba(0,0,0,0)","rgba(0,0,0,0)"],
        data: [270*core_freq/600, 270*(600-core_freq)/600, 90],
        backgroundColor: ["rgba(153,255,51,0.6)", "rgba(0,0,0,0)", "rgba(0,0,0,0)"]
        }
      ]
    },
    options: {tooltips:{enabled:false}, title:{display:true, text:["CORE", core_freq], padding:-74}, rotation: 0.75 * Math.PI, animation:{animateScale: true}}
  });
}
