(function($) {
  "use strict";

  jQuery.expr[":"].Equals = function(a, i, m) {
    return (a.textContent || a.innerText || "").toUpperCase() === m[3].toUpperCase();
  };

  $.fn.multifilter = null;
  $.fn.multifilter = function(options) {
    var settings = $.extend( {
      'target'    : $('table'),
      'method'    : 'thead' // This can be thead or class
    }, options);

    this.each(function() {
      var $this = $(this);
      var container = settings.target;
      var item_tag = 'td';

      if (settings.method === 'thead') {
        // Match the data-col attribute to the text in the thead
        var col = container.find('th:Equals(' + $this.data('col') + ')');
        var col_index = container.find($('thead th')).index(col);
      };

      if (settings.method === 'class') {
        // Match the data-col attribute to the class on each column
        var row_tag = 'tr';
        var rows = container.find($(row_tag));
        var col = rows.first().find('td.' + $this.data('col'));
        var col_index = rows.first().find('td').index(col);
      };

      $this.on('change focusin focusout', function() {
        var filter = $this.val();
        $('#salamisandwich  tbody  tr').each(function() {
          var row = $(this);
          var cell = $(row.children(item_tag)[col_index]);
          if (filter) {
            if (cell.text().toLowerCase().indexOf(filter.toLowerCase()) !== -1) {
              row.show();
            } else {
              row.hide();
            }
          } else {
            row.show();
          }
        });
        return false;
      }).keyup(function() {
        $this.change();
      });
    });
  };
})(jQuery);
